const {registerBlockType} = wp.blocks; //Blocks API
const {createElement} = wp.element; //React.createElement
const {__} = wp.i18n; //translation functions
const {InspectorControls} = wp.editor; //Block inspector wrapper
const {TextControl,ServerSideRender} = wp.components; //WordPress form inputs and server-side renderer

registerBlockType( 'hercules-blocks/display-widgets', {
	title: __( 'Hercules Display widgets area' ), // Block title.
	icon: 'shortcode',
	category:  __( 'common' ), //category
	attributes:  {
		id : {
		type: 'string',
			default: '',
		},
		cssclass: {
		type: 'string',
			default: ''
		}
	},
	//display the post title
	edit(props){
		const attributes =  props.attributes;
		const setAttributes =  props.setAttributes;

		//Function to update id attribute
		function changeId(id){
			setAttributes({id});
		}

		//Function to update heading level
		function changeHeading(cssclass){
			setAttributes({cssclass});
		}

		//Display block preview and UI
		return createElement('div', {}, [
			'Sidebar ID ' + attributes.id,
			//Block inspector
			createElement( InspectorControls, {},
				[
					//A simple text control for post id
					createElement(TextControl, {
						value: attributes.id,
						label: __( 'Sidebar ID' ),
						onChange: changeId
					}),
					//Select cssclass
					createElement(TextControl, {
						value: attributes.cssclass,
						label: __( 'Custom css class' ),
						onChange: changeHeading
					})
				]
			)
		] )
	},
	save(){
		return null;//save has to exist. This all we need
	}
});
