<?php
include_once (ABSPATH.'wp-admin/includes/plugin.php');
if (!is_plugin_active('jetpack/jetpack.php')) {
	// widget visibility
	if (!class_exists('Jetpack_Widget_Conditions')) {
		include_once(plugin_dir_path(__FILE__).'widget-conditions.php');
	}
}

/*
custom Page Walker CSS
*/
function buzzblogpro_widgets_style() {
	echo '<style>';
	echo '.widget-padding { display: inline-block;vertical-align: middle;padding: 5px;text-align:center; }.widget-padding label,.widget-headings {display: block;}.wp-picker-container,.color-field-label{display: inline-block;}';
	echo '</style>';
}
add_action( 'admin_print_styles-widgets.php', 'buzzblogpro_widgets_style' );



add_action( 'admin_enqueue_scripts', 'buzzblogpro_enqueue_scripts' );
function buzzblogpro_enqueue_scripts( $hook_suffix ) {
		if ( 'widgets.php' !== $hook_suffix ) {
			return;
		}

		wp_enqueue_style( 'wp-color-picker' );
		wp_enqueue_script( 'wp-color-picker' );
		wp_enqueue_script( 'underscore' );
}



add_action( 'admin_footer-widgets.php', 'buzzblogpro_print_scripts', 9999 );

function buzzblogpro_print_scripts() {
		?>
		<script>
			( function( $ ){
				function initColorPicker( widget ) {
					widget.find( '.color-field' ).wpColorPicker( {
						change: _.throttle( function() { // For Customizer
							$(this).trigger( 'change' );
						}, 3000 )
					});
				}

				function onFormUpdate( event, widget ) {
					initColorPicker( widget );
				}

				$( document ).on( 'widget-added widget-updated', onFormUpdate );

				$( document ).ready( function() {
					$( '#widgets-right .widget:has(.color-field)' ).each( function () {
						initColorPicker( $( this ) );
					} );
				} );
			}( jQuery ) );
		</script>
		<?php
}

//widget-attributes

class Hercules_Widget_Attributes {

	const VERSION = '0.2.2';

	public static function setup() {
		if ( is_admin() ) {
			// Add necessary input on widget configuration form
			add_action( 'in_widget_form', array( __CLASS__, '_input_fields' ), 10, 3 );

			// Save widget attributes
			add_filter( 'widget_update_callback', array( __CLASS__, '_save_attributes' ), 10, 4 );
		}
		else {
			// Insert attributes into widget markup
			add_filter( 'dynamic_sidebar_params', array( __CLASS__, '_insert_attributes' ) );
		}
	}

	public static function _input_fields( $widget, $return, $instance ) {
		$instance = self::_get_attributes( $instance );
		?>
			<p>
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-class' ) ),
					esc_html__( 'Predefined Css Class(es)', 'widget-attributes' )
				) ?>
				
				
							<select id="<?php echo esc_attr( $widget->get_field_id( 'widget-class' ) ); ?>" name="<?php echo esc_attr( $widget->get_field_name( 'widget-class' ) ); ?>" class="widefat categories" style="width:100%;">
				<option value='stylenone' <?php if ('stylenone' == $instance['widget-class']) echo 'selected="selected"'; ?>>default</option>
				<option value='style1' <?php if ('style1' == $instance['widget-class']) echo 'selected="selected"'; ?>>style1 - padding:30px;background: #f7f7f7;</option>
				<option value='style2' <?php if ('style2' == $instance['widget-class']) echo 'selected="selected"'; ?>>style2 - padding:30px;border:1px solid #f7f7f7;</option>
				<option value='style3' <?php if ('style3' == $instance['widget-class']) echo 'selected="selected"'; ?>>style3 - padding:30px;border:6px solid #222222;</option>
				<option value='style4' <?php if ('style4' == $instance['widget-class']) echo 'selected="selected"'; ?>>style4 - padding:30px;border:4px double #f7f7f7;</option>
				<option value='style5' <?php if ('style5' == $instance['widget-class']) echo 'selected="selected"'; ?>>style5 - padding:30px;background: #ffffff;</option>
				<option value='style6' <?php if ('style6' == $instance['widget-class']) echo 'selected="selected"'; ?>>style6 - padding:45px;background: #ffffff;</option>
				<option value='style7' <?php if ('style7' == $instance['widget-class']) echo 'selected="selected"'; ?>>style7 - padding:45px;background: #f7f7f7;</option>
				<option value='style8' <?php if ('style8' == $instance['widget-class']) echo 'selected="selected"'; ?>>style8 - margin-bottom:35px;border-bottom: 1px solid #eeeeee;</option>
				<option value='style9' <?php if ('style9' == $instance['widget-class']) echo 'selected="selected"'; ?>>style9 - margin-bottom:35px;</option>
				<option value='style10' <?php if ('style10' == $instance['widget-class']) echo 'selected="selected"'; ?>>style10 - margin-bottom:45px;</option>
				<option value='style11' <?php if ('style11' == $instance['widget-class']) echo 'selected="selected"'; ?>>style11 - margin-bottom:35px;padding:30px 30px;background: #ffffff;</option>
				<option value='style12' <?php if ('style12' == $instance['widget-class']) echo 'selected="selected"'; ?>>style12 - margin:0px;padding:45px;background: #f7f7f7;</option>
				<option value='style13' <?php if ('style13' == $instance['widget-class']) echo 'selected="selected"'; ?>>style13 - border-top: 10px solid #f9f9f9;</option>
				<option value='style14' <?php if ('style14' == $instance['widget-class']) echo 'selected="selected"'; ?>>style14 - dark</option>
				<option value='fullwidth-widget' <?php if ('fullwidth-widget' == $instance['widget-class']) echo 'selected="selected"'; ?>>fullwidth widget</option>
			</select>
			
			</p>
			
			<p>
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-custom-class' ) ),
					esc_html__( 'Custom css class', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widefat" id="%s" name="%s" value="%s" />',
					esc_attr( $widget->get_field_id( 'widget-custom-class' ) ),
					esc_attr( $widget->get_field_name( 'widget-custom-class' ) ),
					esc_attr( $instance['widget-custom-class'] )
				) ?>
			</p>
			<fieldset style="border:1px solid #F1F1F1; padding:10px 10px 0; margin-bottom:1em;">
  <legend style="padding:0 5px;"><?php esc_html_e('Widget appearance settings', 'buzzblogpro'); ?>:</legend>
			<p>
				<?php printf(
					'<label class="color-field-label" for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-custom-background' ) ),
					esc_html__( 'Widget background color', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="color-field" id="%s" name="%s" value="%s" />',
					esc_attr( $widget->get_field_id( 'widget-custom-background' ) ),
					esc_attr( $widget->get_field_name( 'widget-custom-background' ) ),
					esc_attr( $instance['widget-custom-background'] )
				) ?>
			</p>
			<div class="widgets-padding-wrap">
			<span class="widget-headings">Widget padding:</span>
						<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-padding-top' ) ),
					esc_html__( 'top', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-padding-top' ) ),
					esc_attr( $widget->get_field_name( 'widget-padding-top' ) ),
					esc_attr( $instance['widget-padding-top'] )
				) ?>
			</p>
									<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-padding-left' ) ),
					esc_html__( 'left', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-padding-left' ) ),
					esc_attr( $widget->get_field_name( 'widget-padding-left' ) ),
					esc_attr( $instance['widget-padding-left'] )
				) ?>
			</p>
												<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-padding-bottom' ) ),
					esc_html__( 'bottom', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-padding-bottom' ) ),
					esc_attr( $widget->get_field_name( 'widget-padding-bottom' ) ),
					esc_attr( $instance['widget-padding-bottom'] )
				) ?>
			</p>
															<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-padding-right' ) ),
					esc_html__( 'right', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-padding-right' ) ),
					esc_attr( $widget->get_field_name( 'widget-padding-right' ) ),
					esc_attr( $instance['widget-padding-right'] )
				) ?>
			</p>
			<span class="widget-headings">Widget margin:</span>
			<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-margin-top' ) ),
					esc_html__( 'top', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-margin-top' ) ),
					esc_attr( $widget->get_field_name( 'widget-margin-top' ) ),
					esc_attr( $instance['widget-margin-top'] )
				) ?>
			</p>
			<p class="widget-padding">
				<?php printf(
					'<label for="%s">%s</label>',
					esc_attr( $widget->get_field_id( 'widget-margin-bottom' ) ),
					esc_html__( 'bottom', 'widget-attributes' )
				) ?>
				<?php printf(
					'<input type="text" class="widget-padding" id="%s" name="%s" value="%s" maxlength="3" size="3" />',
					esc_attr( $widget->get_field_id( 'widget-margin-bottom' ) ),
					esc_attr( $widget->get_field_name( 'widget-margin-bottom' ) ),
					esc_attr( $instance['widget-margin-bottom'] )
				) ?>
			</p>
			
			
			</div>
			</fieldset>
		<?php
		return null;
	}

	private static function _get_attributes( $instance ) {
		$instance = wp_parse_args(
			$instance,
			array(
				'widget-class' => '',
				'widget-custom-class' => '',
				'widget-custom-background' => '',
				'widget-padding-top' => '',
				'widget-padding-left' => '',
				'widget-padding-bottom' => '',
				'widget-padding-right' => '',
				'widget-margin-top' => '',
				'widget-margin-bottom' => '',
			)
		);

		return $instance;
	}

	public static function _save_attributes( $instance, $new_instance, $old_instance, $widget ) {
		$instance['widget-class'] = '';
        $instance['widget-custom-class'] = '';
		$instance['widget-custom-background'] = '';
		$instance['widget-padding-top'] = '';
		$instance['widget-padding-left'] = '';
		$instance['widget-padding-bottom'] = '';
		$instance['widget-padding-right'] = '';
		$instance['widget-margin-top'] = '';
		$instance['widget-margin-bottom'] = '';
		// Classes
		if ( !empty( $new_instance['widget-class'] ) ) {
			$instance['widget-class'] = $new_instance['widget-class'];

		}
		else {
			$instance['widget-class'] = '';
		}
		
				// Custom Classes
		if ( !empty( $new_instance['widget-custom-class'] ) ) {
			$instance['widget-custom-class'] = apply_filters(
				'widget_attribute_classes',
				implode(
					' ',
					array_map(
						'sanitize_html_class',
						explode( ' ', $new_instance['widget-custom-class'] )
					)
				)
			);
		}
		else {
			$instance['widget-custom-class'] = '';
		}
		
		// Background
		if ( !empty( $new_instance['widget-custom-background'] ) ) {
			$instance['widget-custom-background'] = $new_instance['widget-custom-background'];

		}
		else {
			$instance['widget-custom-background'] = '';
		}
		
				if ( isset( $new_instance['widget-padding-top'] ) ) {
			$instance['widget-padding-top'] = $new_instance['widget-padding-top'];

		}
		else {
			$instance['widget-padding-top'] = '';
		}
						if ( isset( $new_instance['widget-padding-left'] ) ) {
			$instance['widget-padding-left'] = $new_instance['widget-padding-left'];

		}
		else {
			$instance['widget-padding-left'] = '';
		}
								if ( isset( $new_instance['widget-padding-bottom'] ) ) {
			$instance['widget-padding-bottom'] = $new_instance['widget-padding-bottom'];

		}
		else {
			$instance['widget-padding-bottom'] = '';
		}
								if ( isset( $new_instance['widget-padding-right'] ) ) {
			$instance['widget-padding-right'] = $new_instance['widget-padding-right'];

		}
		else {
			$instance['widget-padding-right'] = '';
		}
		
										if ( isset( $new_instance['widget-margin-top'] ) ) {
			$instance['widget-margin-top'] = $new_instance['widget-margin-top'];

		}
		else {
			$instance['widget-margin-top'] = '';
		}
										if ( isset( $new_instance['widget-margin-bottom'] ) ) {
			$instance['widget-margin-bottom'] = $new_instance['widget-margin-bottom'];

		}
		else {
			$instance['widget-margin-bottom'] = '';
		}
		

		return $instance;
	}

	public static function _insert_attributes( $params ) {
		global $wp_registered_widgets;

		$widget_id  = $params[0]['widget_id'];
		$widget_obj = $wp_registered_widgets[ $widget_id ];

		if (
			!isset( $widget_obj['callback'][0] )
			|| !is_object( $widget_obj['callback'][0] )
		) {
			return $params;
		}

		$widget_options = get_option( $widget_obj['callback'][0]->option_name );
		if ( empty( $widget_options ) )
			return $params;

		$widget_num	= $widget_obj['params'][0]['number'];
		if ( empty( $widget_options[ $widget_num ] ) )
			return $params;

		$instance = $widget_options[ $widget_num ];


		// Classes
		if ( ! empty( $instance['widget-class'] ) ) {
			$params[0]['before_widget'] = preg_replace(
				'/class="/',
				sprintf( 'class="%s ', $instance['widget-class']  ),
				$params[0]['before_widget'],
				1
			);
		}
		
				// Custom Classes
		if ( ! empty( $instance['widget-custom-class'] ) ) {
			$params[0]['before_widget'] = preg_replace(
				'/class="/',
				sprintf( 'class="%s ', $instance['widget-custom-class'] ),
				$params[0]['before_widget'],
				1
			);
		}
		
		$backgroundcolor = $paddingtop = $paddingleft = $paddingbottom = $paddingright = $margintop = $marginbottom = '';
		if ( isset( $instance['widget-margin-top'] ) && $instance['widget-margin-top']!=='' ) {
		$margintop = 'margin-top:'. $instance['widget-margin-top'] . 'px;';
		}
		if ( isset( $instance['widget-margin-bottom'] ) && $instance['widget-margin-bottom']!=='' ) {
		$marginbottom = 'margin-bottom:'. $instance['widget-margin-bottom'] . 'px;';
		}
		
		if ( ! empty( $instance['widget-custom-background'] ) ) {
		$backgroundcolor = 'background:'. $instance['widget-custom-background'] . ';';
		}
		if ( isset( $instance['widget-padding-top'] ) && $instance['widget-padding-top']!=='' ) {
		$paddingtop = 'padding-top:'. $instance['widget-padding-top'] . 'px;';
		}
		if ( isset( $instance['widget-padding-left'] ) && $instance['widget-padding-left']!=='' ) {
		$paddingleft = 'padding-left:'. $instance['widget-padding-left'] . 'px;';
		}
		if ( isset( $instance['widget-padding-bottom'] ) && $instance['widget-padding-bottom']!=='' ) {
		$paddingbottom = 'padding-bottom:'. $instance['widget-padding-bottom'] . 'px;';
		}
		if ( isset( $instance['widget-padding-right'] ) && $instance['widget-padding-right']!=='' ) {
		$paddingright = 'padding-right:'. $instance['widget-padding-right'] . 'px;';
		}
		$custompadding = 'style="'.$backgroundcolor.$paddingtop.$paddingleft.$paddingbottom.$paddingright.'"';
		$custommargin = 'style="'.$margintop.$marginbottom.'"';
		if ( ! empty( $instance['widget-custom-background'] ) or (isset( $instance['widget-padding-top'] ) && $instance['widget-padding-top']!=='') or (isset( $instance['widget-padding-left'] ) && $instance['widget-padding-left']!=='') or (isset( $instance['widget-padding-bottom'] ) && $instance['widget-padding-bottom']!=='') or (isset( $instance['widget-padding-right'] ) && $instance['widget-padding-right']!=='' )) {	
		$params[0]['before_widget'] = preg_replace('/class="widget-content"/', ' class="widget-content" '.$custompadding.'', $params[0]['before_widget'], 1);
		}
				if ( (isset( $instance['widget-margin-top'] ) && $instance['widget-margin-top']!=='') or (isset( $instance['widget-margin-bottom'] ) && $instance['widget-margin-bottom']!=='') ) {
		$params[0]['before_widget'] = preg_replace('/data-widgetmargin="true"/', $custommargin, $params[0]['before_widget'], 1);
		}

		return $params;
	}
}

add_action( 'widgets_init', array( 'Hercules_Widget_Attributes', 'setup' ) );