<?php
	class buzzblogpro_youtube_subscribe_button_widget extends WP_Widget {

	function __construct() {

		$widget_ops = array(
			'classname' => 'buzzblogpro_youtube_subscribe_button_widget', 
			'description'=> esc_html__('Enable users to subscribe to your YouTube channel with one click.', 'buzzblogpro') 
		);

		parent::__construct(
			'buzzblogpro_youtube_subscribe_button_widget',
			esc_html__('Hercules - Youtube subscribe button', 'buzzblogpro'),
			$widget_ops
		);

	}

		function widget($args, $instance) {
			extract(array_merge($args , $instance));
			echo wp_kses_post( $args['before_widget'] );
 if ( $title ) {
			echo wp_kses_post( $args['before_title'] . $title . $args['after_title'] );
		} 
        $channel_id_var = ($instance['channel_id'])?$instance['channel_id']:'';	 
if($channel_id_var != '') {		
	    $layout_var    		= (isset($layout) && $layout=='on')?'full':'default';	     
	    $theme_var   		= (isset($theme) && $theme=='on')?'dark':'default';	     
	    $count_var    		= (isset($count) && $count=='on')?'hidden':'default';	 
		$buttonalign_var  = (isset($buttonalign) && $buttonalign=='on')?'style="text-align:center;"':'';
		$bgcolor_var		= (isset($bgcolor) && $bgcolor=='on')?'remove':'';
		?> 
		<style type="text/css">
		.dark_theme{
<?php if($bgcolor_var !='remove') {echo esc_attr('background: rgb(85, 85, 85);');}?>
			}
		</style>
		<div class="ytsubscribe_container <?php echo esc_attr($theme_var);?>_theme" <?php echo $buttonalign_var;?>>
			<script src="https://apis.google.com/js/platform.js"></script>
			<div class="g-ytsubscribe" data-channelid="<?php echo esc_attr($channel_id_var); ?>" data-layout="<?php echo esc_attr($layout_var); ?>" data-theme="<?php echo esc_attr($theme_var);?>" data-count="<?php echo esc_attr($count_var);?>"></div>
		</div>
<?php
}else{
esc_html_e('No YouTube channel id', 'buzzblogpro');
}
			
			echo wp_kses_post( $args['after_widget'] );
		}

		public function update( $new_instance, $old_instance ) {
			return $new_instance;
		}

		public function form($instance) {
			$defaults = array(
				'title' => '',
				'channel_id' => '',
				'layout' => '',
				'theme' => '',
				'buttonalign' => '',
				'bgcolor' => '',
				'count' => '',
			);
			extract(array_merge($defaults, $instance));

			$form_field_type = array(
				'title' => array('type' => 'text', 'class' => 'widefat', 'inline_style' => '',  'title' => esc_html__('Title', 'buzzblogpro'), 'description' => '', 'value' => $title),
				'channel_id' => array('type' => 'text', 'class' => 'widefat channel_id', 'inline_style' => '',  'title' => esc_html__('YouTube Channel ID', 'buzzblogpro'), 'description' => '', 'value' => $channel_id),
				'layout' => array('type' => 'checkbox', 'class' => 'widefat layout', 'inline_style' => '',  'title' => esc_html__('Show full layout', 'buzzblogpro'), 'description' => '', 'value' => $layout),
				'theme' => array('type' => 'checkbox', 'class' => 'widefat', 'inline_style' => '', 'title' => esc_html__('Show dark theme', 'buzzblogpro'), 'description' => '', 'value' => $theme),
				'buttonalign' => array('type' => 'checkbox', 'class' => 'widefat', 'inline_style' => '', 'title' => esc_html__('Align button to center?', 'buzzblogpro'), 'description' => '', 'value' => $buttonalign),
				'bgcolor' => array('type' => 'checkbox', 'class' => 'widefat', 'inline_style' => '', 'title' => esc_html__('Remove background color to set your own widget background color.', 'buzzblogpro'), 'description' => '', 'value' => $bgcolor),
				'count' => array('type' => 'checkbox', 'class' => '', 'inline_style' => '', 'title' => esc_html__('Hide the number of subscribers', 'buzzblogpro'), 'description' => '', 'value' => $count)
			);

			$output = '';
			foreach ($form_field_type as $key => $args) {
				$field_id = esc_attr($this->get_field_id($key));
				$field_name = esc_attr($this->get_field_name($key));
				$field_class = $args['class'];
				$field_title = $args['title'];
				$field_description = $args['description'];
				$field_value = $args['value'];
				$field_options = isset($args['value_options']) ? $args['value_options'] : array() ;
				$inline_style = $args['inline_style'] ? 'style="'.$args['inline_style'].'"' : '' ;

				
				$output .= '<p>';
				
				switch ($args['type']) {
					case 'text':
						$output .= '<label '.$inline_style.' for="'.$field_id.'">'.$field_title.': <input '.$inline_style.' class="'.$field_class.'" id="'.$field_id.'" name="'.$field_name.'" type="text" value="'.esc_attr($field_value).'" /></label>';
					break;
					case 'checkbox':
						$checked = isset($instance[$key]) ? 'checked' : '' ;
						$output .= '<label for="'.$field_id.'"><input value="on" '.$inline_style.' class="'.$field_class.'" id="'.$field_id.'" name="'.$field_name.'" type="checkbox" '.$checked.' />'.$field_title.'</label>';
					break;
				}
                if($field_description) {				
				$output .= '<br><small style="display:block;color:#aaa;">'.$field_description.'</small>';
				}
				$output .= '</p>';
			}
			
			echo balanceTags($output);
		}
	}
?>